"""Tools for working with text data

Available modules:
    - longest_common_substring
    - longest_sentence_subsequence_plagiarism_detector
    - RegexRulesClassifier
    - StringCleaner
"""

# pylint: disable=unused-import

from joes_giant_toolbox.all.longest_common_substring import longest_common_substring

from joes_giant_toolbox.all.longest_sentence_subsequence_plagiarism_detector import (
    longest_sentence_subsequence_plagiarism_detector,
)

from joes_giant_toolbox.all.regex_rules_classifier import RegexRulesClassifier

from joes_giant_toolbox.all.string_cleaner import StringCleaner
